#ifndef IRSSI_GJS_CLASSES_XS_MACROS_H_
#define IRSSI_GJS_CLASSES_XS_MACROS_H_

#include "functions-xs-macros.h"

#define SG_B_TOBJ(klass)	*vp._ = OBJECT_TO_JSVAL(gjs_irssi_c_bless_object(cx, #klass,
#define SG_E_TOBJ(x)	))
#define SG_B_STR			*vp._ = safe_make_js_string(cx,
#define SG_E_STR			)
#define SG_B_INT			*vp._ = INT_TO_JSVAL(
#define SG_E_INT			)
#define SG_B_IOBJ			SG_B_TOBJ(iobject)
#define SG_E_IOBJ			SG_E_TOBJ(iobject)
#define SG_B_BOOL			*vp._ = BOOLEAN_TO_JSVAL(
#define SG_E_BOOL			)
#define SG_B_TOBJARR(klass)	{			\
    GSList   *tmp;				\
    JSObject *ret;				\
    uint32_t  i = 0;					\
    ret = JS_NewArrayObject(cx, 0, NULL);		\
    for (tmp = 
#define		 SG_E_TOBJARR(klass)	; tmp != NULL; tmp = tmp->next) {	\
      jsval r;								\
      r = OBJECT_TO_JSVAL(gjs_irssi_c_bless_object(cx, #klass, tmp->data));	\
      JS_SetElement(cx, ret, i++, &r);					\
    }									\
    *vp._ = OBJECT_TO_JSVAL(ret);				\
  }
#define SG_B_IOBJARR SG_B_TOBJARR(iobject)
#define SG_E_IOBJARR SG_E_TOBJARR(iobject)
#define SG_B_STRPTRARR	{			\
    char   **tmp;				\
    JSObject *ret;				\
    uint32_t  i = 0;					\
    ret = JS_NewArrayObject(cx, 0, NULL);		\
    for (tmp = 
#define		 SG_E_STRPTRARR	; tmp != NULL; tmp++) {	\
      jsval r;						\
      r = safe_make_js_string(cx, *tmp);		\
      JS_SetElement(cx, ret, i++, &r);			\
    }							\
    *vp._ = OBJECT_TO_JSVAL(ret);			\
  }


#define SC_IMPL(klass, name, cv, impl) \
  SCRIPT_GETTER(klass, name) {						\
    nRV;								\
    BEGIN;								\
    SG_B_ ## cv impl SG_E_ ## cv ;					\
    END0;								\
  }

#define SG_IMPL(klass, name, nklass, cv, impl)				\
  SCRIPT_GETTER(klass, name) {						\
    nRV;								\
    nklass *N;								\
    BEGIN;								\
    N = JS_GetPrivate(*obj._);						\
    if (!N)								\
      goto SCX_cleanup;							\
    SG_B_ ## cv impl SG_E_ ## cv ;					\
    END;								\
  }
#define SGS_IMPL(klass, name, nklass, cv) SG_IMPL(klass, name, nklass, cv, N-> name)

/** ST_INT_IMPL
 * implement integer constants
 * \param klass class name with underscores
 * \param prop property(constant) name
 */
#define SC_INT_IMPL(klass, prop)	\
JSBool                                                            \
static gjs_ ## ## klass ## _get_ ## prop                       \
 (JSContext *cx, JSHandleObject obj, JSHandleId id, JSMutableHandleValue vp) { \
  SG_B_INT prop SG_E_INT ;						\
  return JS_TRUE;							\
}

#define SCV_INT_IMPL(klass, pfx, prop)				  \
JSBool                                                            \
static gjs_ ## ## klass ## _get_ ## prop                       \
 (JSContext *cx, JSHandleObject obj, JSHandleId id, JSMutableHandleValue vp) { \
  SG_B_INT pfx ## _ ## prop SG_E_INT ;					\
    return JS_TRUE;							\
}

/** various class registration macros */

/** naming scheme:
 * C global variables:

 gjs_ KLASS_NAME _ FUNCTION_NAME	(native fun) SCRIPT_FUN    / FUN_DEF
 gjs_ KLASS_NAME _get_ PROP_NAME	(native fun) SCRIPT_GETTER / PROP_GETTER_DEF

 gjs_ KLASS_NAME _proto		(JSObject *)	DECLARE_CLASS
 gjs_ KLASS_NAME _cto		(JSObject *)	DECLARE_CLASS
 gjs_ KLASS_NAME _class		(JSClass)	MAKE_ABSTRACT_CLASS
 gjs_ KLASS_NAME _constructor	(native fun)	MAKE_ABSTRACT_CLASS
 gjs_ KLASS_NAME _proto_funs	(JSFunctionSpec[])	FUN_SPEC_TBL(KLASS_NAME _proto)
 gjs_ KLASS_NAME _proto_props	(JSPropertySpec[])	PROP_SPEC_TBL(KLASS_NAME _proto)
  (^ only used for constants of irssi main class)
 gjs_ KLASS_NAME _props		(JSPropertySpec[])	PROP_SPEC_TBL(KLASS_NAME)
  (^ object props installed by the class registerer / c_bless)
 gjs_ KLASS_NAME _static_funs	(JSFunctionSpec[])	FUN_SPEC_TBL(KLASS_NAME _static)
 gjs_ KLASS_NAME _static_props	(JSPropertySpec[])	PROP_SPEC_TBL(KLASS_NAME _static)

 * Irssi/ C klass mapping:
 CLASS_ADD_MAP(id_str("WINDOW ITEM TYPE", "XXX"), Irssi::Xxx);
 CLASS_ADD_MAP(id("XXX", 0), Irssi::Xxx);
 */

/* generic class initialiser */
/* S = with static funs & props */
/* R = call register */
#define INIT_CLASS_DS(klass, namespace_parent_obj, namespace_parent_name, co_nn, const_ps, sconst_ps, static_funs, parent_proto) \
  if (!gjs_init_class_dynamic(cx, gjs_ ## namespace_parent_obj ## _cto,	\
			      parent_proto,				\
			      namespace_parent_name, co_nn,		\
			      &gjs_ ## klass ## _class,			\
			      gjs_ ## klass ## _constructor, 0,		\
			      const_ps /* proto_ps */, gjs_ ## klass ## _proto_funs, \
			      sconst_ps /* static_ps */, static_funs,		\
			      &gjs_ ## klass ## _proto, &gjs_ ## klass ## _cto)) \
    goto out;
/* without static props and funs */
#define INIT_CLASS_D(klass, namespace_parent_obj, namespace_parent_name, co_nn, const_ps, parent_proto) \
  INIT_CLASS_DS(klass, namespace_parent_obj, namespace_parent_name, co_nn, const_ps, NULL, NULL, parent_proto)

/* 0 = helper only */
#define REGISTER_CLASS0(klass_name, parent_var, ps_var)			\
  {									\
    IrssiGjsClassInfo *info = g_new0(IrssiGjsClassInfo, 1);			\
    info->proto = gjs_ ## klass_name ## _proto;				\
    info->klass = &gjs_ ## klass_name ## _class;				\
    info->ps = ps_var;							\
    info->parent = parent_var;						\
    g_hash_table_insert(gjs_irssi_class_table, (void *)gjs_ ## klass_name ## _class . name, \
			info);						\
  }

/* 0 = helper only */
#define REGISTER_CLASS0_PROPS(klass, parent_var) REGISTER_CLASS0(klass, parent_var, gjs_ ## klass ## _props)

/* register class into hash table - without parent, - without properties */
#define REGISTER_CLASS(klass) REGISTER_CLASS0(klass, NULL, NULL)
/* register class into hash table - without parent, with properties */
#define REGISTER_CLASS_PROPS(klass) REGISTER_CLASS0_PROPS(klass, NULL)

/* 2 = with parent, get parent by name from register hash table */
/* register class into hash table, - with parent (Irssi::Xxx), - without properties */
#define REGISTER_CLASS2(xklass, parent_klass)	\
  REGISTER_CLASS0(xklass,						\
		  ((IrssiGjsClassInfo *)g_hash_table_lookup(gjs_irssi_class_table, #parent_klass ))->klass->name, NULL)

/* register class, - with parent (Irssi::Xxx), - with properties */
#define REGISTER_CLASS2_PROPS(xklass, parent_klass)			\
  REGISTER_CLASS0_PROPS(xklass,						\
			((IrssiGjsClassInfo *)g_hash_table_lookup(gjs_irssi_class_table, #parent_klass ))->klass->name)

/* C variable prefix, C variable suffix, C string prefix, C string suffix (with proper casing) */
/* - no static, - no object props/funs */
#define INIT_CLASS(pvn, nk, co_pn, co_nn)			\
  INIT_CLASS_D(pvn ## _ ## nk , pvn, co_pn, co_nn, NULL, NULL)

/* - no object props/funs, - no static props, - with static funs */
#define INIT_CLASS_S(pvn, nk, co_pn, co_nn)			\
  INIT_CLASS_DS(pvn ## _ ## nk , pvn, co_pn, co_nn, NULL, NULL,	\
		gjs_ ## pvn ## _ ## nk ## _static_funs, NULL)

/* no object props/funs, static props+static funs */
#define INIT_CLASS_SPROPS(pvn, nk, co_pn, co_nn)			\
  INIT_CLASS_DS(pvn ## _ ## nk , pvn, co_pn, co_nn, NULL,	\
		gjs_ ## pvn ## _ ## nk ## _static_props, gjs_ ## pvn ## _ ## nk ## _static_funs, NULL)

/* R = call register */
#define INIT_CLASS_R(pvn, nk, co_pn, co_nn)			\
  INIT_CLASS(pvn, nk, co_pn, co_nn);		\
  REGISTER_CLASS(pvn ## _ ## nk)

#define INIT_CLASS_PROPS_R(pvn, nk, co_pn, co_nn)			\
  INIT_CLASS_D(pvn ## _ ## nk , pvn, co_pn, co_nn, NULL, NULL); \
  REGISTER_CLASS_PROPS(pvn ## _ ## nk)

#define INIT_CLASS_S_PROPS_R(pvn, nk, co_pn, co_nn)			\
  INIT_CLASS_DS(pvn ## _ ## nk , pvn, co_pn, co_nn, NULL, NULL,		\
		gjs_ ## pvn ## _ ## nk ## _static_funs, NULL);		\
  REGISTER_CLASS_PROPS(pvn ## _ ## nk)

#define INIT_CLASS2_R(pvn, nk, co_pn, co_nn, parent_klass)		\
  INIT_CLASS_D(pvn ## _ ## nk , pvn, co_pn, co_nn,			\
	       NULL,							\
	       ((IrssiGjsClassInfo *)g_hash_table_lookup(gjs_irssi_class_table, #parent_klass ))->proto); \
  REGISTER_CLASS2(pvn ## _ ## nk, parent_klass)

#define INIT_CLASS2_PROPS_R(pvn, nk, co_pn, co_nn, parent_klass)	\
  INIT_CLASS_D(pvn ## _ ## nk , pvn, co_pn, co_nn,			\
	       NULL,							\
	       ((IrssiGjsClassInfo *)g_hash_table_lookup(gjs_irssi_class_table, #parent_klass ))->proto); \
  REGISTER_CLASS2_PROPS(pvn ## _ ## nk, parent_klass)

#define INIT_CLASS2_S_PROPS_R(pvn, nk, co_pn, co_nn, parent_klass)		\
  INIT_CLASS_DS(pvn ## _ ## nk , pvn, co_pn, co_nn,			\
		NULL, NULL, gjs_ ## pvn ## _ ## nk ## _static_funs,	\
	       ((IrssiGjsClassInfo *)g_hash_table_lookup(gjs_irssi_class_table, #parent_klass ))->proto); \
  REGISTER_CLASS2_PROPS(pvn ## _ ## nk, parent_klass)

#define INIT_CLASS_WITH_CONSTS(pvn, nk, co_pn, co_nn)		\
  INIT_CLASS_D(pvn ## _ ## nk , pvn, co_pn, co_nn,		\
	       gjs_ ## pvn ## _ ## nk ## _proto_props, NULL)

#endif
