#include "console-irc.h"

#include "classes-irc.h"

static MODULE_FILE_REC* irssi_module;

DLLEXPORT
void
irc_js_init() {
  JSContext *cx;
  JSObject *global;
  int chat_type;

  if (!js_context) {
    g_message("JS context not loaded");
    goto out;
  }

  cx = gjs_context_get_native_context(js_context);
  global = gjs_get_import_global(cx);

  if (!init_classes_irc(cx, global))
    goto error_cleanup;

  chat_type = chat_protocol_lookup("IRC");

  CLASS_ADD_MAP(id_str("WINDOW ITEM TYPE", "CHANNEL"), Irssi::Irc::Channel);
  CLASS_ADD_MAP(id("SERVER", 0), Irssi::Irc::Server);
  CLASS_ADD_MAP(id("SERVER CONNECT", 0), Irssi::Irc::Connect);

  irssi_module = module_register("js", "irc");

  goto out;
error_cleanup:
out:
  return;
}

DLLEXPORT
void
irc_js_deinit() {
}
