#include "functions.h"
#include "functions-xs-macros.h"
#include "utils.h"
#include "classes.h"
#include "irssi-bits.h"

void
script_settings_add_str(const char *s1, const char *s2, const char *s3) {}
void
script_settings_add_int(const char *s1, const char *s2, int i3) {}
void
script_settings_add_bool(const char *s1, const char *s2, int i3) {}
void
script_settings_add_time(const char *s1, const char *s2, const char *s3) {}
void
script_settings_add_level(const char *s1, const char *s2, const char *s3) {}
void
script_settings_add_size(const char *s1, const char *s2, const char *s3) {}
void
script_settings_remove(const char *s1) {}
jsval
script_format_create_dest(SERVER_REC *n1, const char *s2, int i3, WINDOW_REC *n4) { return JSVAL_NULL; }
JSBool
script_printformat(JSContext *cx, TEXT_DEST_REC *dest, char *format, char **arglist) {
  nSCX;
  nRV;
  char *module;
  char *subm;
  int formatnum;

  get_cSCX;

  if ((subm = strrchr(format, '/'))) {
    subm[0] = '\0';
    module = g_strdup(format);
    subm[0] = '/';
    subm++;
  }
  else {
    char *script_cs;
    script_cs = decode_js_string(cx, JSVAL_TO_STRING(sCX));
    module = g_strdup_printf("JS/Script/%s", script_cs);
    g_free(script_cs);
    subm = format;
  }

  formatnum = format_find_tag(module, subm);
  if (formatnum < 0) {
    JS_ReportError(cx, "printformat: unregistered format '%s'", format);
    goto out;
  }

  printformat_module_dest_charargs(module, dest, formatnum, arglist);
  rv = JS_TRUE;
 SCX_cleanup:
 out:
  g_free(module);
  return rv;
}


SCRIPT_FUN(core_print) {
  SF_VARS("S");

  char *script_name;

  SF_BEGIN;

  script_name = decode_js_string(cx, JSVAL_TO_STRING(sCX));

  printtext_window(NULL, 0, "JS/%s: %s", script_name, a[0].s);

  JS_free(cx, script_name);

  RV(JSVAL_VOID);
  SF_END;
}

SCRIPT_FUN(irssi_print) {
  SF_VARS("S/j");
  a[1].i = MSGLEVEL_CLIENTNOTICE;

  SF_BEGIN;
    
  printtext_string(NULL, NULL, a[1].i, a[0].s);

  RV(JSVAL_VOID);
  SF_END;
}

SCRIPT_FUN(irssi_abstracts_register) { /* SVptr $abstracts XXX */ }
SCRIPT_FUN(irssi_command_bind) { /* ... XXX */ }
SCRIPT_FUN(irssi_command_bind_first) { /* ... XXX */ }
SCRIPT_FUN(irssi_command_bind_last) { /* ... XXX */ }
SCRIPT_FUN(irssi_command_parse_options) { /* string $cmd, string $data XXX */ }
SCRIPT_FUN(irssi_command_runsub) { /* string $cmd, string $data, Irssi::Server $server, Irssi::Windowitem $item XXX */ }
SCRIPT_FUN(irssi_command_set_options) { /* string $cmd, string $options XXX */ }
SCRIPT_FUN(irssi_command_unbind) { /* string $cmd, SVptr $func XXX */ }
SCRIPT_FUN(irssi_expando_create) { /* string $key, SVptr $func, SVptr $signals XXX */ }
SCRIPT_FUN(irssi_expando_destroy) { /* string $name XXX */ }
SCRIPT_FUN(irssi_format_create_dest) { /* string $target, int $level, Irssi::UI::Window $window */
  SF_VARS("S/jo");
  WINDOW_REC *native;
  a[1].i = MSGLEVEL_CLIENTNOTICE;
  SF_BEGIN;
  ALLOW_NULL_N(native, a[2].o, irssi_ui_window);
  RV(script_format_create_dest(NULL, a[0].s, a[1].i, native));
  SF_END;
}
SCRIPT_FUN(irssi_input_add) { /* int $source, int $condition, SVptr $func, SVptr $data XXX */ }
SCRIPT_FUN(irssi_input_remove) { /* int $tag XXX */ }
SCRIPT_FUN(irssi_parse_special) { /* string $cmd, string $data, int $flags */
  SF_VARS("S/Sj");
  SF_BEGIN;
  if (!a[1].s)
    a[1].s = g_strdup("");
  B_XSTR parse_special_string(a[0].s, NULL, NULL, a[1].s, NULL, a[2].i) E_XSTR;
  SF_END;
}
SCRIPT_FUN(irssi_printformat) { /* int $level, string $format, ... */
  SF_VARS("jS/");
  char *fmt_args[MAX_FORMAT_PARAMS + 1];
  TEXT_DEST_REC dest;
  unsigned n;
  SF_BEGIN;

  format_create_dest(&dest, NULL, NULL, a[0].i, NULL);
  memset(fmt_args, 0, sizeof(fmt_args));
  for (n = 2; n < argc && n < MAX_FORMAT_PARAMS + 2; n++) {
    JSString *str = JS_ValueToString(cx, argv[n]);
    fmt_args[n - 2] = decode_js_string(cx, str);
  }
  rv = script_printformat(cx, &dest, a[1].s, fmt_args);
  for (n = 2; n < argc && n < MAX_FORMAT_PARAMS + 2; n++)
    g_free(fmt_args[n - 2]);

  RV(JSVAL_VOID);
  SF_END;
}
SCRIPT_FUN(irssi_server_create_conn) { /* int $chat_type, string $dest, int $port, string $chatnet, string $password, string $nick */
  SF_VARS("jS/jSSS");
  SF_BEGIN;
  B_IOBJ server_create_conn(a[0].i, a[1].s, a[2].i, a[3].s, a[4].s, a[5].s) E_IOBJ;
  SF_END;
}
SCRIPT_FUN(irssi_signal_add_first) { /* ... XXX */ }
SCRIPT_FUN(irssi_signal_add_last) { /* ... XXX */ }
SCRIPT_FUN(irssi_signal_add_priority) { /* ... XXX */ }
SCRIPT_FUN(irssi_signal_continue) { /* ... XXX */ }
SCRIPT_FUN(irssi_signal_emit) { /* string $signal, ... XXX */ }
SCRIPT_FUN(irssi_signal_register) { /* ... XXX */ }
SCRIPT_FUN(irssi_statusbar_item_register) { /* string $name, string $value, string $func XXX */ }
SCRIPT_FUN(irssi_statusbar_item_unregister) { /* string $name XXX */ }
SCRIPT_FUN(irssi_theme_register) { /* SVptr $formats XXX */ }
SCRIPT_FUN(irssi_timeout_add) { /* int $msecs, SVptr $func, SVptr $data XXX */ }
SCRIPT_FUN(irssi_timeout_add_once) { /* int $msecs, SVptr $func, SVptr $data XXX */ }
SCRIPT_FUN(irssi_timeout_remove) { /* int $tag XXX */ }
SCRIPT_FUN(irssi_version) {
  SF0_VARS;
  BEGIN;
  B_XSTR g_strdup_printf("%d.%04d", IRSSI_VERSION_DATE, IRSSI_VERSION_TIME) E_XSTR;
  END0;
}

SCRIPT_FUN(irssi_ui_window_format_create_dest) { /* Irssi::UI::Window $window, int $level */
  SFV_VARS("/j", WINDOW_REC);
  a[0].i = MSGLEVEL_CLIENTNOTICE;
  SV_BEGIN(irssi_ui_window);
  RV(script_format_create_dest(NULL, NULL, a[0].i, N));
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_change_server) { /* Irssi::UI::Window $window, Irssi::Server $server */
  SFV_VARS("o", WINDOW_REC);
  SERVER_REC *server;
  SV_BEGIN(irssi_ui_window);
  
  CHECK_VN(server, a[0].o, irssi_server);
  
  window_change_server(N, server);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_command) { /* Irssi::UI::Window $window, string $cmd */
  SFV_VARS("S", WINDOW_REC);
  WINDOW_REC *old;
  SV_BEGIN(irssi_ui_window);

  old = active_win;
  active_win = N;
  irssi_script_command(a[0].s, N->active_server, N->active);
  if (active_win == N && g_slist_find(windows, old) != NULL)
    active_win = old;
  RV(JSVAL_VOID);

  SV_END;
}
SCRIPT_FUN(irssi_ui_window_format_get_text) { /* Irssi::UI::Window $window, string $module, Irssi::Server $server, string $target, int $formatnum, ... XXX */
  SFV_VARS("SoSS/", WINDOW_REC);
  TEXT_DEST_REC dest;
  THEME_REC *theme;
  SERVER_REC *server;
  char **charargs;
  char *ret;
  int formatnum;
  int n;
  SV_BEGIN(irssi_ui_window);
  ALLOW_NULL_N(server, a[1].o, irssi_server);
  charargs = g_new0(char *, argc - 4 + 1);
  for (n = 4; n < argc; n++) {
    JSString *str = JS_ValueToString(cx, argv[n]);
    charargs[n - 4] = decode_js_string(cx, str);
  }

  format_create_dest(&dest, server, a[2].s, 0, N);
  theme = window_get_theme(dest.window);
  formatnum = format_find_tag(a[0].s, a[3].s);

  ret = format_get_text_theme_charargs(theme, a[0].s, &dest, formatnum, charargs);
  charargs = g_new0(char *, argc - 4 + 1);
  for (n = 4; n < argc; n++) {
    g_free(charargs[n - 4]);
  }
  g_free(charargs);

  RV(safe_make_js_string(cx, ret));
  g_free(ret);
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_get_history_lines) { /* Irssi::UI::Window $window */
  SFV_VARS("", WINDOW_REC);
  HISTORY_REC *rec;
  GList *tmp;
  JSObject *ret;
  uint32_t  i = 0;
  SV_BEGIN(irssi_ui_window);
  rec = command_history_current(N);
  ret = JS_NewArrayObject(cx, 0, NULL);
  for (tmp = rec->list; tmp != NULL; tmp = tmp->next) {
      jsval r;
      r = safe_make_js_string(cx, tmp->data);
      JS_SetElement(cx, ret, i++, &r);
  }
  JS_RVAL(cx,vp) = OBJECT_TO_JSVAL(ret);
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_gui_printtext_after) { /* Irssi::UI::Window $window, Irssi::TextUI::Line $prev, int $level, string $str, time_t $time */
  SFV_VARS("ojS/j", WINDOW_REC);
  TEXT_DEST_REC dest;
  LINE_REC *prev = NULL;
  a[3].i = 0;
  SV_BEGIN(irssi_ui_window);
  
  ALLOW_NULL_N(prev, a[0].o, irssi_textui_line);
  
  format_create_dest(&dest, NULL, NULL, a[1].i, N);
  gui_printtext_after_time(&dest, prev, a[2].s, a[3].i);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_server_gui_printtext_after) { /* Irssi::Server $server, string $target, Irssi::TextUI::Line $prev, int $level, string $str, time_t $time */
  SFV_VARS("SojS/j", SERVER_REC);
  TEXT_DEST_REC dest;
  LINE_REC *prev = NULL;
  a[4].i = 0;
  SV_BEGIN(irssi_server);
  
  ALLOW_NULL_N(prev, a[1].o, irssi_textui_line);
  
  format_create_dest(&dest, N, a[0].s, a[2].i, NULL);
  gui_printtext_after_time(&dest, prev, a[3].s, a[4].i);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_item_add) { /* Irssi::UI::Window $window, Irssi::Windowitem $item, int $automatic */
  SFV_VARS("ob", WINDOW_REC);
  WI_ITEM_REC *wi = NULL;
  SV_BEGIN(irssi_ui_window);
  CHECK_VN(wi, a[0].o, irssi_windowitem);
  window_item_add(N, wi, a[1].b);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_item_destroy) { /* Irssi::Windowitem $item */
  SF_VARS("o");
  WI_ITEM_REC *wi = NULL;
  SF_BEGIN;
  
  CHECK_VN(wi, a[0].o, irssi_windowitem);
  
  window_item_destroy(wi);
  RV(JSVAL_VOID);
  SF_END;
}
SCRIPT_FUN(irssi_ui_window_item_find) { /* Irssi::UI::Window $window, Irssi::Server $server, string $name */
  SFV_VARS("oS", WINDOW_REC);
  SERVER_REC *server = NULL;
  SV_BEGIN(irssi_ui_window);
  
  ALLOW_NULL_N(server, a[0].o, irssi_server);
  
  B_IOBJ window_item_find_window(N, server, a[1].s) E_IOBJ;
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_item_remove) { /* Irssi::Windowitem $item */
  SF_VARS("o");
  WI_ITEM_REC *wi = NULL;
  SF_BEGIN;
  CHECK_VN(wi, a[0].o, irssi_windowitem);
  window_item_remove(wi);
  RV(JSVAL_VOID);
  SF_END;
}
SCRIPT_FUN(irssi_ui_window_print) { /* Irssi::UI::Window $window, string $str, int $level */
  SFV_VARS("S/j", WINDOW_REC);
  a[1].i = MSGLEVEL_CLIENTNOTICE;

  SV_BEGIN(irssi_ui_window);

  printtext_string_window(N, a[1].i, a[0].s);

  RV(JSVAL_VOID);

  SV_END;
}
SCRIPT_FUN(irssi_ui_window_print_after) { /* Irssi::UI::Window $window, Irssi::TextUI::Line $prev, int $level, string $str, time_t $time */
  SFV_VARS("ojS/j", WINDOW_REC);
  TEXT_DEST_REC dest;
  char *text;
  char *text2;
  LINE_REC *prev = NULL;
  a[3].i = 0;
  SV_BEGIN(irssi_ui_window);
  
  ALLOW_NULL_N(prev, a[0].o, irssi_textui_line);
  
  format_create_dest(&dest, NULL, NULL, a[1].i, N);
  text = format_string_expand(a[2].s, NULL);
  text2 = g_strconcat(text, "\n", NULL);
  gui_printtext_after_time(&dest, prev, text2, a[3].i);
  g_free(text);
  g_free(text2);
  
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_ui_window_printformat) { /* Irssi::UI::Window $window, int $level, string $format, ... */
  SFV_VARS("jS/", WINDOW_REC);
  char *fmt_args[MAX_FORMAT_PARAMS + 1];
  TEXT_DEST_REC dest;
  unsigned n;
  SV_BEGIN(irssi_ui_window);

  format_create_dest(&dest, NULL, NULL, a[0].i, N);
  memset(fmt_args, 0, sizeof(fmt_args));
  for (n = 2; n < argc && n < MAX_FORMAT_PARAMS + 2; n++) {
    JSString *str = JS_ValueToString(cx, argv[n]);
    fmt_args[n - 2] = decode_js_string(cx, str);
  }
  rv = script_printformat(cx, &dest, a[1].s, fmt_args);
  for (n = 2; n < argc && n < MAX_FORMAT_PARAMS + 2; n++)
    g_free(fmt_args[n - 2]);

  RV(JSVAL_VOID);
  SV_END;
}


SCRIPT_FUN(irssi_server_format_create_dest) { /* Irssi::Server $server, string $target, int $level, Irssi::UI::Window $window */
  SFV_VARS("/.Sjo", SERVER_REC);
  WINDOW_REC *window;
  SV_BEGIN(irssi_server);
  ALLOW_NULL_N(window, a[2].o, irssi_ui_window);
  RV(script_format_create_dest(N, a[0].s, a[1].i, window));
  SV_END;
}
SCRIPT_FUN(irssi_server_nicks_get_same) { /* Irssi::Server $server, string $nick */
  SFV_VARS("S", SERVER_REC);
  GSList *list, *tmp;
  JSObject *ret;
  uint32_t  i = 0;
  SV_BEGIN(irssi_server);
  list = nicklist_get_same(N, a[0].s);
  ret = JS_NewArrayObject(cx, 0, NULL);
  for (tmp = list; tmp != NULL; tmp = tmp->next->next) {
    jsval r1, r2;
    r1 = OBJECT_TO_JSVAL(gjs_irssi_c_bless_object(cx, "iobject", tmp->data));
    r2 = OBJECT_TO_JSVAL(gjs_irssi_c_bless_object(cx, "iobject", tmp->next->data));
    JS_SetElement(cx, ret, i++, &r1);
    JS_SetElement(cx, ret, i++, &r2);
  }
  JS_RVAL(cx,vp) = OBJECT_TO_JSVAL(ret);
  g_slist_free(list);
  SV_END;
}
SCRIPT_FUN(irssi_server_parse_special) { /* Irssi::Server $server, string $cmd, string $data, int $flags */
  SFV_VARS("S/Sj", SERVER_REC);
  a[2].i = 0;
  SV_BEGIN(irssi_server);
  if (!a[1].s)
    a[1].s = g_strdup("");
  B_XSTR parse_special_string(a[0].s, N, NULL, a[1].s, NULL, a[2].i) E_XSTR;
  SV_END;
}
SCRIPT_FUN(irssi_server_print) { /* Irssi::Server $server, string $channel, string $str, int $level */
  SFV_VARS(".SS/j", SERVER_REC);
  a[2].i = MSGLEVEL_CLIENTNOTICE;
  SV_BEGIN(irssi_server);
  printtext_string(N, a[0].s, a[2].i, a[1].s);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_server_printformat) { /* Irssi::Server $server, string $target, int $level, string $format, ... */
  SFV_VARS("SjS/", SERVER_REC);
  char *fmt_args[MAX_FORMAT_PARAMS + 1];
  TEXT_DEST_REC dest;
  unsigned n;
  SV_BEGIN(irssi_server);

  format_create_dest(&dest, N, a[0].s, a[1].i, NULL);
  memset(fmt_args, 0, sizeof(fmt_args));
  for (n = 3; n < argc && n < MAX_FORMAT_PARAMS + 3; n++) {
    JSString *str = JS_ValueToString(cx, argv[n]);
    fmt_args[n - 3] = decode_js_string(cx, str);
  }
  rv = script_printformat(cx, &dest, a[2].s, fmt_args);
  for (n = 3; n < argc && n < MAX_FORMAT_PARAMS + 3; n++)
    g_free(fmt_args[n - 3]);

  RV(JSVAL_VOID);
  SV_END;
}
/* SCRIPT_FUN(irssi_server_ref) */ /* Irssi::Server $server */
/* SCRIPT_FUN(irssi_server_unref) */ /* Irssi::Server $server */


SCRIPT_FUN(irssi_windowitem_change_server) { /* Irssi::Windowitem $item, Irssi::Server $server */
  SFV_VARS("o", WI_ITEM_REC);
  SERVER_REC *server;
  SV_BEGIN(irssi_windowitem);
  CHECK_VN(server, a[0].o, irssi_server);
  window_item_change_server(N, server);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_windowitem_parse_special) { /* Irssi::Windowitem $item, string $cmd, string $data, int $flags */
  SFV_VARS("S/Sj", WI_ITEM_REC);
  a[2].i = 0;
  SV_BEGIN(irssi_windowitem);
  if (!a[1].s)
    a[1].s = g_strdup("");
  B_XSTR parse_special_string(a[0].s, N->server, N, a[1].s, NULL, a[2].i) E_XSTR;
  SV_END;
}
SCRIPT_FUN(irssi_windowitem_print) { /* Irssi::Windowitem $item, string $str, int $level */
  SFV_VARS("S/j", WI_ITEM_REC);
  a[1].i = MSGLEVEL_CLIENTNOTICE;

  SV_BEGIN(irssi_windowitem);

  printtext_string(N->server, N->visible_name, a[1].i, a[0].s);

  RV(JSVAL_VOID);

  SV_END;
}
SCRIPT_FUN(irssi_windowitem_printformat) { /* Irssi::Windowitem $item, int $level, string $format, ... */
  SFV_VARS("jS/", WI_ITEM_REC);
  char *fmt_args[MAX_FORMAT_PARAMS + 1];
  TEXT_DEST_REC dest;
  unsigned n;
  SV_BEGIN(irssi_windowitem);

  format_create_dest(&dest, N->server, N->visible_name, a[0].i, NULL);
  memset(fmt_args, 0, sizeof(fmt_args));
  for (n = 2; n < argc && n < MAX_FORMAT_PARAMS + 2; n++) {
    JSString *str = JS_ValueToString(cx, argv[n]);
    fmt_args[n - 2] = decode_js_string(cx, str);
  }
  rv = script_printformat(cx, &dest, a[1].s, fmt_args);
  for (n = 2; n < argc && n < MAX_FORMAT_PARAMS + 2; n++)
    g_free(fmt_args[n - 2]);

  RV(JSVAL_VOID);
  SV_END;
}


SCRIPT_FUN(irssi_channel_nick_insert) { /* Irssi::Channel $channel, Irssi::Nick $nick */
  SFV_VARS("o", CHANNEL_REC);
  NICK_REC *nick;
  SV_BEGIN(irssi_channel);
  CHECK_VN(nick, a[0].o, irssi_nick);
  nicklist_insert(N, nick);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_channel_nick_remove) { /* Irssi::Channel $channel, Irssi::Nick $nick */
  SFV_VARS("o", CHANNEL_REC);
  NICK_REC *nick;
  SV_BEGIN(irssi_channel);
  CHECK_VN(nick, a[0].o, irssi_nick);
  nicklist_remove(N, nick);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_channel_nicks) { /* Irssi::Channel $channel */
  SFV_VARS("", CHANNEL_REC);
  GSList *list;
  SV_BEGIN(irssi_channel);
  list = nicklist_getnicks(N);
  B_IOBJARR list E_IOBJARR;
  g_slist_free(list);
  SV_END;
}

SCRIPT_FUN(irssi_query_change_server) { /* Irssi::Query $query, Irssi::Server $server */
  SFV_VARS("o", QUERY_REC);
  SERVER_REC *server;
  SV_BEGIN(irssi_query);
  CHECK_VN(server, a[0].o, irssi_server);
  query_change_server(N, server);
  RV(JSVAL_VOID);
  SV_END;
}



SCRIPT_FUN(irssi_log_item_destroy) { /* Irssi::Log $log, Irssi::Logitem $item */
  SFV_VARS("o", LOG_REC);
  LOG_ITEM_REC *item;
  SV_BEGIN(irssi_log);
  CHECK_VN(item, a[0].o, irssi_logitem);
  log_item_destroy(N, item);
  RV(JSVAL_VOID);
  SV_END;
}

SCRIPT_FUN(irssi_textui_line_get_text) { /* Irssi::TextUI::Line $line, int $coloring */
  SFV_VARS("b", LINE_REC);
  GString *str;
  SV_BEGIN(irssi_textui_line);
  str = g_string_new(NULL);
  textbuffer_line2text(N, a[0].b, str);
  B_STR str->str E_STR;
  g_string_free(str, TRUE);
  SV_END;
}

SCRIPT_FUN(irssi_textui_textbufferview_get_line_cache) { /* Irssi::TextUI::TextBufferView $view, Irssi::TextUI::Line $line */
  SFV_VARS("o", TEXT_BUFFER_VIEW_REC);
  LINE_REC *line;
  SV_BEGIN(irssi_textui_textbufferview);
  CHECK_VN(line, a[0].o, irssi_textui_line);
  B_TOBJ(Irssi::TextUI::LineCache)
    textbuffer_view_get_line_cache(N, line)
    E_TOBJ(Irssi::TextUI::LineCache);
  SV_END;
}
SCRIPT_FUN(irssi_textui_textbufferview_remove_line) { /* Irssi::TextUI::TextBufferView $view, Irssi::TextUI::Line $line */
  SFV_VARS("o", TEXT_BUFFER_VIEW_REC);
  LINE_REC *line;
  SV_BEGIN(irssi_textui_textbufferview);
  CHECK_VN(line, a[0].o, irssi_textui_line);
  textbuffer_view_remove_line(N, line);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_textui_textbufferview_set_bookmark) { /* Irssi::TextUI::TextBufferView $view, string $name, Irssi::TextUI::Line $line */
  SFV_VARS("So", TEXT_BUFFER_VIEW_REC);
  LINE_REC *line;
  SV_BEGIN(irssi_textui_textbufferview);
  CHECK_VN(line, a[1].o, irssi_textui_line);
  textbuffer_view_set_bookmark(N, a[0].s, line);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_textui_textbufferview_scroll_line) { /* Irssi::TextUI::TextBufferView $view, Irssi::TextUI::Line $line */
  SFV_VARS("o", TEXT_BUFFER_VIEW_REC);
  LINE_REC *line;
  SV_BEGIN(irssi_textui_textbufferview);
  CHECK_VN(line, a[0].o, irssi_textui_line);
  textbuffer_view_scroll_line(N, line);
  SV_END;
}
SCRIPT_FUN(irssi_textui_statusbaritem_default_handler) { /* Irssi::TextUI::StatusbarItem $item, int $get_size_only, string $str, string $data, int $escape_vars */
  SFV_VARS("bSS/b", SBAR_ITEM_REC);
  a[3].b = JS_TRUE;
  SV_BEGIN(irssi_textui_statusbaritem);
  statusbar_item_default_handler(N, a[0].b, a[1].s[0] ? a[1].s : NULL, a[2].s, a[3].b);
  RV(JSVAL_VOID);
  SV_END;
}
SCRIPT_FUN(irssi_ui_theme_format_expand) { /* Irssi::UI::Theme $theme, string $format, int $flags */
  SFV_VARS("S/j", THEME_REC);
  char *ret = NULL;
  a[1].i = 0;
  SV_BEGIN(irssi_ui_theme);
  if (a[1].i == 0) {
    ret = theme_format_expand(N, a[0].s);
  } else {
    const char *fp;
#ifdef FORMAT_COLOR_EXT1
    theme_rm_col reset;
    strcpy(reset.m, "n");
#else
    char *reset = "n";
#endif
    fp = a[0].s;
    ret = theme_format_expand_data(N, &fp,
				   reset, reset, NULL, NULL,
				   EXPAND_FLAG_ROOT | a[1].i);
  }
  RV(safe_make_js_string(cx, ret));
  g_free_not_null(ret);
  SV_END;
}
SCRIPT_FUN(irssi_ui_theme_get_format) { /* Irssi::UI::Theme $theme, string $module, string $tag */
  SFV_VARS("SS", THEME_REC);
  MODULE_THEME_REC *modtheme;
  FORMAT_REC *formats;
  int i;
  char *ret;
  SV_BEGIN(irssi_ui_theme);

  formats = g_hash_table_lookup(default_formats, a[0].s);
  if (formats == NULL) {
    JS_ReportError(cx, "get_format: Unknown module: %s", a[0].s);
    goto SCX_cleanup;
  }

  for (i = 0; formats[i].def != NULL; i++) {
    if (formats[i].tag != NULL &&
	g_ascii_strcasecmp(formats[i].tag, a[1].s) == 0)
      break;
  }

  if (formats[i].def == NULL) {
    JS_ReportError(cx, "get_format: Unknown format tag: %s", a[1].s);
    goto SCX_cleanup;
  }

  modtheme = g_hash_table_lookup(N->modules, a[0].s);
  ret = modtheme == NULL ? NULL : modtheme->formats[i];
  if (ret == NULL)
    ret = formats[i].def;
  B_STR ret E_STR;
 
  SV_END;
}


#if 0
SCRIPT_FUN[Irssi::Ignore :: add_rec] { /* Irssi::Ignore $rec */ }
SCRIPT_FUN[Irssi::Ignore :: update_rec] { /* Irssi::Ignore $rec */ }
#endif
